package org.processmining.dataawarereplayer.precision.visualizer;

import java.util.Collection;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.dataawarereplayer.precision.PrecisionResult;
import org.processmining.dataawarereplayer.precision.state.PrecisionState;
import org.processmining.dataawarereplayer.precision.state.StateTransition;
import org.processmining.datapetrinets.DataPetriNet;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;

import com.google.common.collect.SetMultimap;

@Plugin(name = "1 Show Observed/Possible per Trace", returnLabels = { "Multi-perspective Precision Measurement" }, //
				returnTypes = { JComponent.class }, level = PluginLevel.PeerReviewed, userAccessible = true, parameterLabels = { "Matching Instances" })
@Visualizer
public class PrecisionResultPrecisionStateVisualizer {

	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualise(PluginContext context, PrecisionResult result) {
		return visualise(context, (DataPetriNet) result.getModel(), result);
	}

	public static JComponent visualise(PluginContext context, DataPetriNet net, PrecisionResult precisionResult) {
		SetMultimap<PrecisionState, StateTransition> possibleStateTransitions = precisionResult
				.getPossibleStateTransitions();
		SetMultimap<PrecisionState, StateTransition> observedStateTransitions = precisionResult
				.getObservedStateTransitions();

		Collection<PrecisionTrace> precisionTraces = PrecisionStateListViewUtils.createPrecisionTraces(precisionResult,
				possibleStateTransitions, observedStateTransitions);

		return PrecisionStateListViewUtils.createPrecisionTraceList(precisionTraces);
	}

}
