/**
 * 
 */
package org.processmining.models.DCNet.visualization;

import java.awt.Color;

import javax.swing.JComponent;
import javax.swing.SwingConstants;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.DCNet.DCNet;
import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.graphbased.ViewSpecificAttributeMap;
import org.processmining.models.jgraph.ProMJGraphVisualizer;
import org.processmining.models.jgraph.visualization.ProMJGraphPanel;
import org.processmining.models.visualcnet.CNetVNode;

@Plugin(name = "000 Visualize DCNet", returnLabels = { "Visualized DCnet" }, returnTypes = { JComponent.class }, parameterLabels = {
		"DCNet" }, userAccessible = false)
@Visualizer
public class DCNetVisualization {
	
	public static DCNetV generateJGraph(DCNet cnet, ViewSpecificAttributeMap viewSpecificMap)
	{
		DCNetV graph = new DCNetV(cnet);
		
		for (CNetVNode node : graph.getNodes()){
			if (node.getNode().equals(cnet.getStartNode())){
				viewSpecificMap.putViewSpecific(node, AttributeMap.STROKECOLOR, Color.GREEN);
				viewSpecificMap.putViewSpecific(node, AttributeMap.BORDERWIDTH, 3);
			}
			
			if (node.getNode().equals(cnet.getEndNode())){
				viewSpecificMap.putViewSpecific(node, AttributeMap.STROKECOLOR, Color.RED);
				viewSpecificMap.putViewSpecific(node, AttributeMap.BORDERWIDTH, 3);
			}	
		}
		return graph;
	}
	
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, DCNet cnet) {
		System.gc();
		// create a graph
		ViewSpecificAttributeMap viewSpecificMap = new ViewSpecificAttributeMap();

		// create a directed graph

		DCNetV graph=generateJGraph(cnet, viewSpecificMap);
		
		ProMJGraphPanel vis = ProMJGraphVisualizer.instance().visualizeGraph(context, graph, viewSpecificMap);

		vis.addViewInteractionPanel(new VariablePnl(cnet), SwingConstants.NORTH);
		return vis;
	}
}
