package org.processmining.plugins.DataConformance.framework;

import java.util.ArrayList;
import java.util.Collection;

//TODO FM, turn this into an interface and allow for different implementations
@SuppressWarnings("serial")
public abstract class ExecutionTrace extends ArrayList<ExecutionStep>
{
	public abstract boolean isComplete();
	
	public abstract Collection<ExecutionTrace> successors(ExecutionStep activity);
	
	protected byte numberOfBottomSteps=0;
	
	public ExecutionTrace(int initialCapacity) {
		super(initialCapacity);
	}
	
	public boolean add(ExecutionStep s) {
		if (s.equals(ExecutionStep.bottomStep))
			numberOfBottomSteps++;
		return super.add(s);	
	}
	
	public boolean addAll(Collection<? extends ExecutionStep> steps, byte numberOfBottomSteps) {
		this.numberOfBottomSteps=numberOfBottomSteps;
		return super.addAll(steps);
	}
	
	public boolean addAll(Collection<? extends ExecutionStep> steps) {
		boolean changed=false;
		for(ExecutionStep step : steps) {
			if (add(step))
				changed=true;
		}
		return changed;
	}
	
	public byte getNumberBottomSteps()
	{
		return numberOfBottomSteps;
	}
	
	public int lengthExecutionTraceWithoutBottomSteps() 
	{
		return this.size()-numberOfBottomSteps;
	}
	
	public ExecutionStep getLast() {
		return this.get(this.size()-1);
	}
	
	public abstract String getTraceName();
			
}
