package org.processmining.plugins.DataConformance.visualization;

import java.awt.Color;

/**
 * Types of a 'move'/'step' in a data alignment
 */
public enum DataAwareStepTypes {
	
	LMGOOD("Move in Both", new Color(0,210,0)), // a bit darker - better to distinguish from yellow for colorblind people 
	LMNOGOOD("Move in Both (Incorrect Data)", Color.WHITE), 
	L("Move in Log", Color.YELLOW), 
	MINVI("Invisible Move", Color.GRAY), 
	MREAL("Move in Model", new Color(224, 176, 255));
	
	private final String label;
	private final Color color;
	
	private DataAwareStepTypes(String label, Color color) {
		this.label = label;
		this.color = color;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Enum#toString()
	 */
	@Override
	public String toString() {
		return label;
	}

	public Color getColor() {
		return color;
	}

}
