/*
 * Copyright (c) 2013 F. Mannhardt (f.mannhardt@tue.nl)
 */
package org.processmining.plugins.balancedconformance.controlflow;

import org.deckfour.xes.model.XEvent;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.plugins.balancedconformance.controlflow.override.DRecord;
import org.processmining.plugins.petrinet.replayresult.StepTypes;

/**
 * Result of the control flow alignment for a single trace
 * 
 * @author F. Mannhardt
 * 
 */
public interface ControlFlowAlignmentResult {

	public interface Step {
		StepTypes getType();
		Transition getModelNode();
		XEvent getLogNode();
		DRecord getRecordForStep();
	}

	XEvent getLastEvent();
	
	Transition getLastTransition();

	DRecord getLastRecord();
	
	Iterable<Step> getSteps();
	
	float getControlFlowCost();
	
	/**
	 * @return approximate size of the control flow alignment (without unmapped events)
	 */
	int getApproximateSize();

}
