package org.processmining.plugins.balancedconformance.controlflow.override.queues.noduplicate;

import org.processmining.plugins.astar.petrinet.impl.AbstractPDelegate;
import org.processmining.plugins.balancedconformance.controlflow.override.DRecord;

import com.google.common.primitives.Ints;

import it.unimi.dsi.fastutil.Hash.Strategy;
import nl.tue.astar.Tail;

public final class BFDataPriorityQueue extends DataFastLookupPriorityQueue {
	
	public BFDataPriorityQueue(int initialCapacity, Strategy<DRecord> strategy,
			AbstractPDelegate<? extends Tail> delegate, int maxCost) {
		super(initialCapacity, strategy, delegate, maxCost);
	}

	public BFDataPriorityQueue(int initialCapacity, Strategy<DRecord> strategy,
			AbstractPDelegate<? extends Tail> delegate) {
		super(initialCapacity, strategy, delegate);
	}

	protected boolean isBetter(DRecord r1, DRecord r2) {
		// retrieve stored cost
		int c1 = r1.getTotalIntegerCost();
		int c2 = r2.getTotalIntegerCost();
		
		if (Ints.compare(c1, c2) < 0 
				// real cost lower first
				|| (Ints.compare(c1, c2) == 0 && r1.getCostSoFar() < r2.getCostSoFar())) {
			return true;
		}
		return false;
	}

}
