package org.processmining.plugins.balancedconformance.dataflow;

import org.processmining.plugins.balancedconformance.controlflow.override.DRecord;
import org.processmining.plugins.balancedconformance.controlflow.override.DataAwareThread.PartialResultFactory;
import org.processmining.plugins.balancedconformance.dataflow.datastate.DataStateFactory;
import org.processmining.plugins.balancedconformance.dataflow.datastate.DataStateStore;
import org.processmining.plugins.balancedconformance.dataflow.exception.DataAlignmentException;
import org.processmining.plugins.balancedconformance.mapping.LogMapping;
import org.processmining.plugins.balancedconformance.mapping.TraceMapping;

import net.sf.javailp.SolverFactory;

public class DataAlignmentAdapterWithoutPartialImpl extends DataAlignmentAdapterMILPImpl {

	private static final PartialDataAlignedTrace EMPTY_DATA_ALIGNMENT = new PartialDataAlignedTrace(0,
			DataStateStore.EMPTY_IMMUTABLE_STATE);

	public DataAlignmentAdapterWithoutPartialImpl(LogMapping mapping, SolverFactory ilpSolver,
			DataStateFactory dataStateFactory, double aStarDelta, boolean includeVirtualVariablesInTrace) {
		super(mapping, ilpSolver, dataStateFactory, aStarDelta, includeVirtualVariablesInTrace, false);
	}

	@Override
	public PartialDataAlignedTrace retrievePartialDataAlignment(TraceMapping traceMapping,
			PartialResultFactory partialResultBuilder, DRecord record) throws DataAlignmentException {
		return EMPTY_DATA_ALIGNMENT;
	}


}
