package org.processmining.plugins.balancedconformance.functions.impl;

import java.util.Map;

import org.processmining.plugins.balancedconformance.functions.Function;

import com.google.common.collect.ImmutableMap;

public final class FunctionRegistry {
	
	private static final Map<String, Function> FUNCTION_MAPPING = ImmutableMap.<String, Function>builder()//
			.put("timeSince", new TimeSinceFunction())
			.put("hourOfDay", new HourOfDayFunction())
			.put("dayOfWeek", new DayOfWeekFunction())
			.put("contains", new StringContainsFunction())
			.put("matches", new StringMatchesFunction())
			.put("startsWith", new StringStartsWithFunction())
			.put("endsWith", new StringEndsWithFunction())
			.build();

	private FunctionRegistry() {
		super();
	}
	
	public static Function getFunction(Object name) {
		return FUNCTION_MAPPING.get(name);
	}

}
